//<c>   Copyright 1986-2000 by Gerry J. Danen; all rights reserved.

//<t>   Report System Equipment

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_files.h"
#include"gd_kb.h"
#include"dsum.ccc"


#define pgTITL_ "Equipment Check"


#define THIS_PGM_SIZE   25L     // size of this program, incl buffers!
#define DIR_MAX         600     // maximum dir. entries
#define MAX_RECLEN      2048    // maximum record length


BOOL    ega_adapter=FALSE, vga_adapter=FALSE, verbose=FALSE, terse=FALSE,
        ynInWindows=FALSE ;
INT16   ega_vga_memory=0 ;
DIRLIST *eDir[ DIR_MAX + 1 ] ;                  // directory entries
SUBDIR  hDir ;                                  // directory header
video_control_t vid ;
UCHAR   sWinDir[FS_LEN] = "", sWinProg[] = "WIN.COM",
        sWinPath[]="C:\\WINDOWS C:\\WIN31 C:\\W C:\\W95 C:\\WIN95 C:\\WINNT" ;


void    line_marker( BOOL before, BOOL after )
{
    UCHAR       uline[81] ;

    if ( before )
        printf( "\n" );
    StrFill( uline, (UCHAR)'', 80 );
    printf( "%s\n", uline );
    if ( after )
        printf( "\n" );
}


void    find_windows_directory( UCHAR winhome[] )
{
    UCHAR       wdir[256], test[256], wpath[256] ;

    winhome[0] = EOS ;
    ST_CPY( test, sWinPath );
    do  {
        st_get_word( wdir, test );              // get possible path
        st_remove_word( test );                 // remove from string
        sprintf( wpath, "%s\\%s", wdir, sWinProg );
        if ( fl_exist( wpath ) )
        {
            strcpy( winhome, wdir );
            test[0] = EOS ;
        }
    }   while( strlen(test) );
}


long    av_memory( void )
{
    char huge   *pstorage ;
    long        storage ;
    int         trying ;

    trying = TRUE ;
    storage = 1024L ;
    do  {
        storage += (100L * 1024L);
        pstorage = _halloc( storage, 1 );
        if ( pstorage == NULL )
            trying = FALSE ;
        else
            _hfree( pstorage );
    }   while ( trying );
    do  {
        storage -= 1024L ;
        pstorage = _halloc( storage, 1 );
    }   while ( pstorage == NULL && storage > 0L );
    _hfree( pstorage );
    return( THIS_PGM_SIZE + ((long) _memavl() + (long) _stackavail() + storage) / 1024L );
}


void    video_status( void )
{
    VideoModeRefresh();
    vga_adapter = is_VGA();
    if ( ! vga_adapter )
        ega_adapter = is_EGA() ;
    ega_vga_memory  = is_EGA() ;
    if ( ega_vga_memory )
    {
        if ( vga_adapter )
            printf( "VGA" );
        else
            printf( "EGA" );                    // assumed...
        printf( " adapter with at least %dK memory\n", ega_vga_memory );
    }
    printf( "Monitor is displaying %d columns, %d lines\nVideo display mode is %d: \"", vid.cols, vid.rows, vid.mode );
    switch ( vid.mode )
    {
        case 0 :
        case 2 :
            printf( "CGA Text B/W" );
            break ;
        case 1 :
        case 3 :
            printf( "CGA Text Color" );
            break ;
        case 4 :
            printf( "CGA Graphics 320x200 Color" );
            break ;
        case 5 :
            printf( "CGA Graphics 320x200 B/W" );
            break ;
        case 6 :
            printf( "CGA Graphics 640x200 B/W" );
            break ;
        case 7 :
            printf( "Monochrome" );
            break ;
        case 13 :
        case 14 :
        case 15 :
        case 16 :
            if ( vga_adapter )
                printf( "VGA mode" );
            else
                printf( "EGA mode" );
            break ;
        default:
            printf( "Advanced mode" );
            break ;
    }
    printf( "\"\n" );
}


void    prt_str( STRING descr, INT16 number, BOOL yesno )
{
    if ( yesno )
    {
        if ( number )
        {
            printf( "\n", number );
            descr[0] = toupper( descr[0] );
        }
        else
            printf( "\nNo " );
        printf( "%s", descr );
    }
    else
    {
        if ( number )
            printf( "\n%d", number );
        else
            printf( "\nNo" );
        printf( " %s%s", descr, ((number != 1) ? "s" : "") );
    }
}


void    pause_display( void )
{
    if ( _isatty( _fileno(stdout) ) )
    {
        fprintf( stderr, "\rHit a key..." );
        _getch();
        fprintf( stderr, "\r            \r" );
    }
}


void    show_dos_version( void )
{
    STRING      note ;
    int         WindowsMode, WinMajorV, WinMinorV ;

    if ( _osmajor == 4 && _osminor == 0 )
        note = "(could be version 4.01check your DOS install disk!)" ;
    else
        note = "" ;
    printf( "DOS version %d.%02d %s\n", _osmajor, _osminor, note );

    WindowsMode = os_windows_check( &WinMajorV, &WinMinorV );
    switch ( WindowsMode )
    {
        case WIN_MODE_ANCIENT :
            ynInWindows = TRUE ;
            printf( "Windows/386 version 2.x active\n" );
            break;
        case WIN_MODE_REAL :
        case WIN_MODE_STANDARD :
            ynInWindows = TRUE ;
            printf( "Windows active in real or standard mode\n" );
            break;
        case WIN_MODE_ENHANCED :
            ynInWindows = TRUE ;
            printf( "Windows %d.%02d active in enhanced mode\n", WinMajorV, WinMinorV );
            break;
    }
    if ( ynInWindows )
        st_get_env_var( "windir", sWinDir, sizeof(sWinDir), "", YES );

    if ( ! strlen(sWinDir) )
        find_windows_directory( sWinDir );

    if ( strlen(sWinDir) )
        printf( "Windows home directory: %s\n", sWinDir );
    else
        printf( "Cannot determine Windows home directory\n" );
}


void    show_file( STRING fname )
{
    FILE        *fin ;
    UCHAR       intext[MAX_RECLEN+1], intext1[MAX_RECLEN+1] ;

    if ( terse )
        return;

//  line_marker( YES, NO );
    if ( fl_exist(fname) )
    {
        strupr( fname );
        printf( "Contents of %s", fname );
        line_marker( YES, NO );
        pause_display();
        if ( (fin = fopen( fname, "r")) == NULL )
            printf( "Could not locate %s, or content is bad!\n", fname );
        while ( ! feof(fin) )
        {
            fgets( intext1, MAX_RECLEN, fin );
            if ( ! feof(fin) )
            {
                st_rtrim( intext1 );                //  get rid of trailing space and cr/lf
                StrDetab( intext, intext1, (MAX_RECLEN+1) );  //  get rid of tabs
                if ( strlen(intext) )               //  anything to print?
                    printf( "%s\n", intext );
            }
        }
        fclose( fin );
        line_marker( NO, NO );
    }
    else
    {
        printf( "System file %s absent\n", fname );
    }
}


void    show_root_dir( void )
{
    UCHAR       filespec[ FS_LEN ] ;            // file specification
    INT16       i, ercode ;

    if ( terse )
        return;

    DIR_init( DIR_MAX, &hDir, eDir );
    strcpy( filespec, "c:\\*.*" );
    ercode = DIR_find( &hDir, eDir, filespec, (_A_RDONLY|_A_HIDDEN|_A_SYSTEM|_A_SUBDIR) );
    if ( ! ercode )
    {
        printf( "Directory of %s\n", hDir.path );
        LOOP( i, 1, hDir.entries, 1 )
        {
            DIR_format_entry( &hDir, eDir, i, filespec, NO );
            st_trim( filespec );
            printf( "%s\n", filespec );
        }
    }
}


void    show_MSCDEX_info( void )
{
    BOOL   status ;
    int    ndrive, MSCDEX_v, MSCDEX_major, MSCDEX_minor ;
    UCHAR  st_drive ;

    if ( ! MSCDEX_installed() )
        return ;

    if ( ! terse )
        line_marker( NO, NO );
    MSCDEX_v = MSCDEX_version( &MSCDEX_major, &MSCDEX_minor );
    printf( "Microsoft CD-ROM Extensions (MSCDEX) version %d.%02d installed\n", MSCDEX_major, MSCDEX_minor );
    if ( MSCDEX_major < 2 )
        printf( "(you should upgrade to MSCDEX version 2.20 or higher!)\n" );
    printf( "\n" );

    ndrive = MSCDEX_cdrom_drives( &st_drive );
    printf( "%d CD-ROM drive%s, starting with drive %c:\n", ndrive, (ndrive==1 ? "" : "s"), st_drive+'@' );

    printf( "\nTesting drives:\n" );
    for ( ndrive = 1 ; ndrive < 27 ; ndrive++ )
    {
        status = dr_is_cdrom( (UCHAR) ndrive );
        switch ( status )
        {
            case TRUE :
                printf( "  drive %c: is a CD-ROM drive\n", '@'+ndrive );
                break ;
            case FALSE :
                break ;
            default :
                printf( "  *** drive %c: is an Invalid Device [%d]\n", '@'+ndrive, status );
        }
    }
}


void    show_NW_info( void )
{
    int         x ;
    WORD        ccode, volNumber, serverConnID ;
    NWVOL_USAGE v ;
    UCHAR       serverName[48], s_kBytes[15] ;
    ULONG       v_tBytes ;

    printf( "NetWare information:\n" );

    GetFileServerName( (WORD) 0, serverName );
    GetConnectionID( serverName, &serverConnID );

    printf( "  Server %s (ConnID=%02X)\n  Volumes:\n", serverName, serverConnID );
    LOOP( x, 0, 31, 1 )
    {
        volNumber = x ;
        ccode = GetVolUsage( serverConnID, volNumber, &v );
        if ( ! ccode )
        {
            if ( ! st_eq(v.volName," ") )
            {
                v.totalBlocks /= SZ_kBYTE ;
                v_tBytes = v.blockSize * v.totalBlocks ;
                Format_UINT32( v_tBytes, s_kBytes );
                printf( "    %12s:  capacity = %9s Kbytes (%d-byte blocks)\n", v.volName, s_kBytes, v.blockSize );
            }
        }
    }
}


void    common_tsrs( void )
{
    STRING fmt = "  %s\n" ;

    printf( "Common drivers/TSRs loaded:\n" );
    if ( ISLOADED_ANSI()    )  printf( fmt, "ANSI.SYS"  );
    if ( ISLOADED_HIMEM()   )  printf( fmt, "HIMEM.SYS" );
    if ( ISLOADED_APPEND()  )  printf( fmt, "APPEND"    );
    if ( ISLOADED_ASSIGN()  )  printf( fmt, "ASSIGN"    );
    if ( ISLOADED_PRINT()   )  printf( fmt, "PRINT"     );
    if ( ISLOADED_NLSFUNC() )  printf( fmt, "NLSFUNC"   );
    if ( ISLOADED_DOSKEY()  )  printf( fmt, "DOSKEY"    );
    if ( ISLOADED_SHARE()   )  printf( fmt, "SHARE"     );
    line_marker( NO, NO );
}


void    main( void )                            //~~~
{
    int         _adapter ;
    equipment_t eq ;
    char        cwork[91], arg[4] ;
    UCHAR       first_drv, last_drv ;
    UINT        bit_pattern=0, kBytes ;
    int         verbose=FALSE, mode, columns, active_page;
    INT16       drive, first_time ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    if ( _isatty( _fileno(stdout) ) )
    {
        ansi_cls( 20, stderr );
        logon( YES );
    }
    else
        fprintf( stderr, "\rCollecting information.  Please wait... \b" );

    CmdLine( cwork );
    _strupr( cwork );
    st_trim( cwork );
    st_cpy ( arg, cwork, 3 );
    if ( strlen(arg) )
    {
        if ( st_eq( arg, "/V" ) )
            verbose = TRUE ;
        else
        if ( st_eq( arg, "/T" ) )
            terse = TRUE ;
        else
        if ( st_eq( arg, "/?" ) )
        {
            printf( "Optional switches: /T = terse mode, /V = verbose mode\n" );
            DIR_exit( eDir );
            exit( BAD_EXIT );
        }
    }

    if ( ! _isatty( _fileno(stdout) ) )
        printf( "This information is produced by \"%s (%s %s)\"\n%s\n\n",
                pgm_title, get_global_program_name(), pgm_vers, pgm_copyrite );

    bit_pattern = ut_get_equipment_info( &eq );

    if ( verbose )
    {
        Binary2Str( bit_pattern, cwork, YES );
        printf( "Equipment status obtained via interrupt 11H - %s", cwork );
        printf( "\n                                              |||| |||| |||| ||||" );
        printf( "\n                                              FEDC BA98 7654 3210" );
        printf( "\nBit 0     diskettes: 1=yes, 0=no" );
        printf( "\nBit 1     1=math coprocessor installed" );
        printf( "\nBit 2-3   number of memory banks on system board (may not be true!)" );
        printf( "\nBit 4-5   initial video mode" );
        printf( "\nBit 6-7   no of diskette drives minus 1 (if bit 0 = 1)" );
        printf( "\nBit 8     0=DMA chip installed" );
        printf( "\nBit 9-B   number of serial ports" );
        printf( "\nBit C     game port: 1=yes, 0=no" );
        printf( "\nBit D     1=internal modem installed" );
        printf( "\nBit E-F   number of parallel ports\n" );
        _adapter = GetVideoMode( &mode, &columns, &active_page );
        printf( "\nBIOS reports:  Adapter=%d  Mode=%d  Cols=%d  ActivePage=%d\n\n", _adapter, mode, columns, active_page );
        pause_display();
    }

    printf( "%s adapter\n", eq.screen_adapter ? "Graphics" : "Monochrome" );
    video_status();

    prt_str( "diskette drive", eq.diskette_drives, 0 );

    prt_str( "parallel port", eq.par_ports, 0 );
    if ( eq.par_ports > 1 && nw_installed_NetWare() )
        printf( " (some could be CAPTUREd for network printing!)" );
    prt_str( "serial port", eq.ser_ports, 0 );
    prt_str( "internal modem", eq.internal_modem, 1 );
    prt_str( "game adapter", eq.game_adapter, 1 );
    prt_str( "math coprocessor", eq.math_coprocessor, 1 );
    printf( "\n" );
    prt_str( "direct memory access (DMA) chip", eq.DMA_chip, 1 );

    if ( verbose )
    {
        prt_str( "bank", eq.s_b_ram_banks, 0 );
        printf( " of RAM on the system board" );
    }
    printf( "\n%dK base memory of which (approx) %ldK are used and (approx) %ldK are free\n",
            eq.total_mem_size, (eq.total_mem_size - av_memory()), av_memory() );
    printf( "(This information may be incorrect if you're loading TSRs high!)\n" );
    kBytes = cmos_get_base_memory() + cmos_get_extended_memory();
    printf( "%uK total memory installed according to CMOS, %uK base + %uK expansion\n",
            kBytes, cmos_get_base_memory(), cmos_get_extended_memory() );

    show_dos_version();

    first_time = TRUE ;
    first_drv = last_drv = SPACE ;
    for ( drive = -1 ; drive < 27 ; drive++ )
    {
        if ( ValidDrive( drive ) )
            if ( first_time )
            {
                first_time = FALSE ;
                first_drv  = (UCHAR) (drive + (int) 'A') ;
            }
            else
                last_drv = (UCHAR) (drive + (int) 'A') ;
    }
    pause_display();

    common_tsrs();
    pause_display();

    printf( "\nAvailable disk drives: %c - %c", first_drv, last_drv );
    line_marker( YES, NO );
    info_about_all_drives( FALSE );
    pause_display();

    if ( ! terse )
    {
        UCHAR *ev ;
        show_file( "C:\\CONFIG.SYS" );
        show_file( "C:\\AUTOEXEC.BAT" );

        ev = GetEnvPar( "GD.STD.INI" );
        if ( ev != NULL )
            ST_CPY( cwork, ev );
        else
            ST_CPY( cwork, "C:\\GD.INI" );
        if ( fl_exist(cwork) )
            show_file( cwork );
        else
            printf( "Global DIS .ini file absent!\nPlease read the docs about configuring the DIS utilities.\n" );

        if ( strlen(sWinDir) )
        {
            UCHAR f[FS_LEN] ;
            sprintf( f, "%s\\%s", sWinDir, "WIN.INI" );
            show_file( f );
            sprintf( f, "%s\\%s", sWinDir, "SYSTEM.INI" );
            show_file( f );
        }

        pause_display();
        show_root_dir();
    }

    show_MSCDEX_info();
    line_marker( NO, NO );
    if ( nw_installed_NetWare() )
        show_NW_info();
    line_marker( NO, NO );

    if ( _isatty( _fileno(stdout) ) )
        fprintf( stderr, "Redirect to disk file or printer for a permanent record\n" );
    else
        fprintf( stderr, "\r%41s\r\n", "" );

    DIR_exit( eDir );
    exit( 0 );
}
